aboutsummaryrefslogtreecommitdiffstats
path: root/bootstrap-hw-tb2.sh
diff options
context:
space:
mode:
authorMiroslav Miklus <mmiklus@cisco.com>2016-03-18 18:28:26 +0100
committerMiroslav Miklus <mmiklus@cisco.com>2016-03-21 17:43:48 +0000
commit14594b423fcb3e4fa3906bdf4fd528998e1b6f09 (patch)
tree72965eb3865573da0335671dffaac86ce6a73c8b /bootstrap-hw-tb2.sh
parent8c7cb6f40ba2eae5be65af023990cd89778f0469 (diff)
Lab reservation tool
This tool provide client-based reservation system of tesbeds by using existing topology files. Change-Id: Ic0be944c77c9d6aa28e3fa7fa69e31d19861416f Signed-off-by: Miroslav Miklus <mmiklus@cisco.com>
Diffstat (limited to 'bootstrap-hw-tb2.sh')
-rwxr-xr-xbootstrap-hw-tb2.sh54
1 files changed, 52 insertions, 2 deletions
diff --git a/bootstrap-hw-tb2.sh b/bootstrap-hw-tb2.sh
index bb5afcaac3..1b889b3039 100755
--- a/bootstrap-hw-tb2.sh
+++ b/bootstrap-hw-tb2.sh
@@ -1,7 +1,26 @@
#!/bin/bash
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
set -x
+# space separated list of available testbeds, described by topology files
+TOPOLOGIES="topologies/available/lf_testbed2-710-520.yaml"
+
+CUR_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
+WORKING_TOPOLOGY=""
+export PYTHONPATH=${CUR_DIR}
+
sudo apt-get -y update
sudo apt-get -y install libpython2.7-dev python-virtualenv
@@ -11,6 +30,37 @@ virtualenv env
echo pip install
pip install -r requirements.txt
-PYTHONPATH=`pwd` pybot -L TRACE \
- -v TOPOLOGY_PATH:topologies/available/lf_testbed2-710-520.yaml \
+#we iterate over available topologies and wait until we reserve topology
+while :; do
+ for TOPOLOGY in ${TOPOLOGIES};
+ do
+ python ${CUR_DIR}/resources/tools/topo_reservation.py -t ${TOPOLOGY}
+ if [ $? -eq 0 ]; then
+ WORKING_TOPOLOGY=${TOPOLOGY}
+ echo "Reserved: ${WORKING_TOPOLOGY}"
+ break
+ fi
+ done
+
+ if [ ! -z "${WORKING_TOPOLOGY}" ]; then
+ #exit the infinite while loop if we made a reservation
+ break
+ fi
+
+ #wait 10 - 30 sec. before next try
+ SLEEP_TIME=$[ ( $RANDOM % 20 ) + 10 ]s
+ echo "Sleeping ${SLEEP_TIME}"
+ sleep ${SLEEP_TIME}
+done
+
+function cancel_reservation {
+ python ${CUR_DIR}/resources/tools/topo_reservation.py -c -t $1
+}
+
+#on script exit we cancel the reservation
+trap "cancel_reservation ${WORKING_TOPOLOGY}" EXIT
+
+#run performance test suite
+pybot -L TRACE \
+ -v TOPOLOGY_PATH:${WORKING_TOPOLOGY} \
-s performance tests/